%define dist_version 2_6_0
%define jaxp_altlevel 120

Name: xalan-j
Version: 2.6.0
Release: alt2

%def_disable xsltc
%def_disable demo

Summary: Java XSLT processor
Group: Development/Java
License: Apache
Url: http://xml.apache.org/xalan-j/

Provides: jaxp_transform_impl = 1.2
Requires: xml-commons-apis
Requires: jaxp_parser_impl

%define javadir		%_datadir/java
%define javadocdir	%_datadir/javadoc
%define pkgdocdir	%_docdir/%name-%version

Source: http://xml.apache.org/dist/xalan-j/%{name}_%{dist_version}-src.tar.bz2
Patch0: %name-2.6.0-manifest.patch

BuildArch: noarch

BuildRequires: j2se-devel ant
BuildRequires: xml-commons-apis
BuildRequires: jaxp_parser_impl
# Don't BuildRequire system stylebook as it BuildRequires xalan-j
BuildRequires: xvfb-run

%if_enabled xsltc
BuildRequires: bcel
BuildRequires: jakarta-regexp
BuildRequires: jaxp_parser_impl
#BuildRequires: jlex
#BuildRequires: java_cup
%endif	# enabled xsltc

%description
Xalan is an XSLT processor for transforming XML documents into HTML,
text, or other XML document types. It implements the W3C Recommendations
for XSL Transformations (XSLT) and the XML Path Language (XPath). It can
be used from the command line, in an applet or a servlet, or as a module
in other program.

%if_enabled xsltc
%package xsltc
Summary: XSLT compiler
Group: Development/Java
Requires: bcel jakarta-regexp jaxp_parser_impl
#Requires: java_cup jlex

%description xsltc
The XSLT Compiler is a Java-based tool for compiling XSLT stylesheets into
lightweight and portable Java byte codes called translets.
%endif	# enabled xsltc

%package manual
Summary: Manual for %name
Group: Development/Java

%description manual
Documentation for Xalan-J, a Java XSLT processor.

%package javadoc
Summary: Javadoc for %name
Group: Development/Java
AutoReqProv: no

%description javadoc
Javadoc-generated API documentation for Xalan-J, a Java XSLT processor.

%if_enabled demo
%package demo
Summary: Demo for %name
Group: Development/Java
Requires: servlet
BuildRequires: servlet
Requires: %name = %epoch:%version-%release

%description demo
Demonstrations and samples for Xalan-J, a Java XSLT processor.
%endif	# enabled demo

%prep
%setup -q -n %{name}_%{dist_version}
%patch0 -p1
# remove all binary libs
#find . -name "*.jar" ! -name "xalan2jdoc.jar" ! -name "stylebook-1.0-b3_xalan-2.jar" -exec rm -f {} \;

%build
xvfb-run ant \
  -Dxmlapis.jar=%javadir/xml-commons-apis.jar \
  -Dparser.jar=%javadir/jaxp_parser_impl.jar \
  xalan-interpretive.jar\
  javadocs.nojardepends \
  docs.nojardepends

%if_enabled xsltc
ant \
  xsltc.unbundledjar \
  xsltc.docs
%endif

%if_enabled demo
ant \
  samples \
  servlet
%endif

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%javadir
install -p -m 644 build/xalan.jar \
  $RPM_BUILD_ROOT%javadir/%name.jar
%if_enabled xsltc
install -p -m 644 build/xsltc.jar \
  $RPM_BUILD_ROOT%javadir/xsltc.jar
%endif

# manual
install -d -m 755 $RPM_BUILD_ROOT%pkgdocdir
cp -a build/docs/* $RPM_BUILD_ROOT%pkgdocdir/

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%javadocdir/%name
mv $RPM_BUILD_ROOT%pkgdocdir/apidocs/* $RPM_BUILD_ROOT%javadocdir/%name/
rmdir $RPM_BUILD_ROOT%pkgdocdir/apidocs
ln -s $(relative %javadocdir/%name %pkgdocdir/) $RPM_BUILD_ROOT%pkgdocdir/apidocs

# license
install -p -m 644 LICENSE NOTICE $RPM_BUILD_ROOT%pkgdocdir/

# alternative
mkdir -p $RPM_BUILD_ROOT%_altdir
cat <<EOF >$RPM_BUILD_ROOT%_altdir/%name
%javadir/jaxp_transform_impl.jar	%javadir/%name.jar	%jaxp_altlevel
EOF

%if_enabled demo
# demo
install -d -m 755 $RPM_BUILD_ROOT%_datadir/%name
install -p -m 644 build/xalansamples.jar \
  $RPM_BUILD_ROOT%_datadir/%name/%name-samples.jar
install -p -m 644 build/xalanservlet.war \
  $RPM_BUILD_ROOT%_datadir/%name/%name-servlet.war
cp -pr samples $RPM_BUILD_ROOT%_datadir/%name
%endif	# enabled demo

%post
%register_alternatives %name -- jaxp_transform_impl

%preun
%unregister_alternatives %name

%files
%dir %pkgdocdir
%pkgdocdir/LICENSE
%pkgdocdir/NOTICE
%javadir/%name.jar
%_altdir/%name

%if_enabled xsltc
%files xsltc
%javadir/xsltc.jar
%endif	# enabled xsltc

%files manual
%dir %pkgdocdir
%pkgdocdir/[b-z]*

%files javadoc
%dir %pkgdocdir
%pkgdocdir/apidocs
%javadocdir/%name

%if_enabled demo
%files demo
%_datadir/%name
%endif	# enabled demo

%changelog
* Fri Aug 27 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt2
- Do not BuildRequire system stylebook as it BuildRequires xalan-j
- New alternatives format (ugh)
- Grouped everything under Development/Java

* Sat Apr 17 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt1
- New upstream release
- Updated manifest patch

* Mon Jan 12 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.5.2-alt3
- Migration to the new alternatives scheme

* Fri Dec 19 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.5.2-alt2
- Build using XML APIs and a JAXP parser installed in the system
- Enabled javadoc back
- Added update-alternatives to install-time dependencies
- Added xml-commons-apis to Requires

* Thu Dec 18 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.5.2-alt1
- New upstream release

* Sat Sep 13 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.5.1-alt1
- Ported to ALT Linux from JPackage project
- Don't build xsltc and demo for now, due to dependencies.
